<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>RecordReader.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">RecordReader.java</span></div><h1>RecordReader.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;

/**
 * Front-end interface to deserializers. Also acts as a factory
 * for deserializers.
 *
 */
public class RecordReader {
    
    private InputArchive archive;

    static private HashMap archiveFactory;
    
    static {
<span class="nc" id="L39">        archiveFactory = new HashMap();</span>
<span class="nc" id="L40">        Class[] params = { InputStream.class };</span>
        try {
<span class="nc" id="L42">            archiveFactory.put(&quot;binary&quot;,</span>
<span class="nc" id="L43">                    BinaryInputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L45">            archiveFactory.put(&quot;csv&quot;,</span>
<span class="nc" id="L46">                    CsvInputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L48">            archiveFactory.put(&quot;xml&quot;,</span>
<span class="nc" id="L49">                    XmlInputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L51">        } catch (SecurityException ex) {</span>
<span class="nc" id="L52">            ex.printStackTrace();</span>
<span class="nc" id="L53">        } catch (NoSuchMethodException ex) {</span>
<span class="nc" id="L54">            ex.printStackTrace();</span>
<span class="nc" id="L55">        }</span>
<span class="nc" id="L56">    }</span>
    
    static private InputArchive createArchive(InputStream in, String format)
    throws IOException {
<span class="nc" id="L60">        Method factory = (Method) archiveFactory.get(format);</span>
<span class="nc bnc" id="L61" title="All 2 branches missed.">        if (factory != null) {</span>
<span class="nc" id="L62">            Object[] params = { in };</span>
            try {
<span class="nc" id="L64">                return (InputArchive) factory.invoke(null, params);</span>
<span class="nc" id="L65">            } catch (IllegalArgumentException ex) {</span>
<span class="nc" id="L66">                ex.printStackTrace();</span>
<span class="nc" id="L67">            } catch (InvocationTargetException ex) {</span>
<span class="nc" id="L68">                ex.printStackTrace();</span>
<span class="nc" id="L69">            } catch (IllegalAccessException ex) {</span>
<span class="nc" id="L70">                ex.printStackTrace();</span>
<span class="nc" id="L71">            }</span>
        }
<span class="nc" id="L73">        return null;</span>
    }
    /**
     * Creates a new instance of RecordReader.
     * @param in Stream from which to deserialize a record
     * @param format Deserialization format (&quot;binary&quot;, &quot;xml&quot;, or &quot;csv&quot;)
     */
    public RecordReader(InputStream in, String format)
<span class="nc" id="L81">    throws IOException {</span>
<span class="nc" id="L82">        archive = createArchive(in, format);</span>
<span class="nc" id="L83">    }</span>
    
    /**
     * Deserialize a record
     * @param r Record to be deserialized
     */
    public void read(Record r) throws IOException {
<span class="nc" id="L90">        r.deserialize(archive, &quot;&quot;);</span>
<span class="nc" id="L91">    }</span>
    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>